Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management.monitor
Class GaugeMonitor

    java.lang.Object
      |
      +--javax.management.NotificationBroadcasterSupport
            |
            +--javax.management.monitor.Monitor
                  |
                  +--javax.management.monitor.GaugeMonitor

All Implemented Interfaces:
  GaugeMonitorMBean, MBeanRegistration, MonitorMBean, NotificationBroadcaster, NotificationEmitter

public class GaugeMonitor
extends Monitor
implements GaugeMonitorMBean

Defines a monitor MBean designed to observe the values of a gauge attribute.

A gauge monitor observes an attribute that is continuously variable with time. A gauge monitor sends notifications as follows:

- if the attribute value is increasing and becomes equal to or greater than the high threshold value, a `threshold high notification` is sent. The notify high flag must be set to `true`
  Subsequent crossings of the high threshold value do not cause further notifications unless the attribute value becomes equal to or less than the low threshold value.
- if the attribute value is decreasing and becomes equal to or less than the low threshold value, a `threshold low notification` is sent. The notify low flag must be set to `true`.
  Subsequent crossings of the low threshold value do not cause further notifications unless the attribute value becomes equal to or greater than the high threshold value.

This provides a hysteresis mechanism to avoid repeated triggering of notifications when the attribute value makes small oscillations around the high or low threshold value.

If the gauge difference mode is used, the value of the derived gauge is calculated as the difference between the observed gauge values for two successive observations.
The derived gauge value (V[t]) is calculated using the following method:

- V[t] = gauge[t] - gauge[t-GP]

This implementation of the gauge monitor requires the observed attribute to be of the type integer or floating-point (`Byte`, `Integer`, `Short`, `Long`, `Float`, `Double`).

Author:
  Young Yang

Field Summary

Fields inherited from class javax.management.monitor.Monitor
`observedObjects`

Constructor Summary
`GaugeMonitor()`

Method Summary
`void` | `addObservedObject(ObjectName objectName)` Adds the specified object in the set of observed MBeans.
`protected void` | `doMonitor(ObjectName observedObject, java.lang.Object value)`
`java.lang.Number` | `getDerivedGauge(ObjectName observedObject)` Gets the derived gauge for the specified MBean.
`long` | `getDerivedGaugeTimeStamp(ObjectName observedObject)` Gets the derived gauge timestamp for the specified MBean.
`boolean` | `getDifferenceMode()` Gets the difference mode flag value.
`java.lang.Number` | `getHighThreshold()` Gets the high threshold value.
`java.lang.Number` | `getLowThreshold()` Gets the low threshold value.
`MBeanNotificationInfo[]` | `getNotificationInfo()` Returns a NotificationInfo object contaning the name of the Java class of the notification and the notification types sent.
`boolean` | `getNotifyHigh()` Gets the high notification's on/off switch value.
`boolean` | `getNotifyLow()` Gets the low notification's on/off switch value.
`void` | `setDifferenceMode(boolean value)` Sets the difference mode flag value.
`void` | `setNotifyHigh(boolean value)` Sets the high notification's on/off switch value.
`void` | `setNotifyLow(boolean value)` Sets the low notification's on/off switch value.
`void` | `setThresholds(java.lang.Number highValue, java.lang.Number lowValue)` Sets the high and the low threshold values.
`void` | `start()`
`void` | `stop()`

Methods inherited from class javax.management.monitor.Monitor
`_start, _stop, containsObservedObject, getGranularityPeriod, getMonitorData, getObservedAttribute, getObservedObjects, isActive, postDeregister, postRegister, preDeregister, preRegister, removeObservedObject, sendNotification, setGranularityPeriod, setObservedAttribute`

Methods inherited from class javax.management.NotificationBroadcasterSupport
`addNotificationListener, handleNotification, removeNotificationListener, removeNotificationListener, sendNotification`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.management.monitor.MonitorMBean
`containsObservedObject, getGranularityPeriod, getObservedAttribute, getObservedObjects, isActive, removeObservedObject, setGranularityPeriod, setObservedAttribute`

Constructor Detail

### GaugeMonitor

    public GaugeMonitor()

Method Detail

### start

    public void start()

  Specified by:
    `start` in class `Monitor`

### stop

    public void stop()

  Specified by:
    `stop` in class `Monitor`

### getDerivedGauge

    public java.lang.Number getDerivedGauge(ObjectName observedObject)

  Description copied from interface: `GaugeMonitorMBean`
  Gets the derived gauge for the specified MBean.

  Specified by:
    `getDerivedGauge` in interface `GaugeMonitorMBean`
  Parameters:
    `observedObject` - the MBean for which the derived gauge is to be returned
  Returns:
    The derived gauge for the specified MBean if this MBean is in the set of observed MBeans, or `null` otherwise.

### getDerivedGaugeTimeStamp

    public long getDerivedGaugeTimeStamp(ObjectName observedObject)

  Description copied from interface: `GaugeMonitorMBean`
  Gets the derived gauge timestamp for the specified MBean.

  Specified by:
    `getDerivedGaugeTimeStamp` in interface `GaugeMonitorMBean`
  Parameters:
    `observedObject` - the MBean for which the derived gauge timestamp is to be returned
  Returns:
    The derived gauge timestamp for the specified MBean if this MBean is in the set of observed MBeans, or `null` otherwise.

### getHighThreshold

    public java.lang.Number getHighThreshold()

  Description copied from interface: `GaugeMonitorMBean`
  Gets the high threshold value.

  Specified by:
    `getHighThreshold` in interface `GaugeMonitorMBean`
  Returns:
    The high threshold value.

### getLowThreshold

    public java.lang.Number getLowThreshold()

  Description copied from interface: `GaugeMonitorMBean`
  Gets the low threshold value.

  Specified by:
    `getLowThreshold` in interface `GaugeMonitorMBean`
  Returns:
    The low threshold value.

### setThresholds

    public void setThresholds(java.lang.Number highValue,
                              java.lang.Number lowValue)
                       throws java.lang.IllegalArgumentException

  Description copied from interface: `GaugeMonitorMBean`
  Sets the high and the low threshold values.

  Specified by:
    `setThresholds` in interface `GaugeMonitorMBean`
  Parameters:
    `highValue` - The high threshold value.
    `lowValue` - The low threshold value.
  Throws:
    `java.lang.IllegalArgumentException` - The specified high/low threshold is null or the low threshold is greater than the high threshold or the high threshold and the low threshold are not of the same type.

### getNotifyHigh

    public boolean getNotifyHigh()

  Description copied from interface: `GaugeMonitorMBean`
  Gets the high notification's on/off switch value.

  Specified by:
    `getNotifyHigh` in interface `GaugeMonitorMBean`
  Returns:
    `true` if the gauge monitor notifies when exceeding the high threshold, `false` otherwise.
  See Also:
    `GaugeMonitorMBean.setNotifyHigh(boolean)`

### setNotifyHigh

    public void setNotifyHigh(boolean value)

  Description copied from interface: `GaugeMonitorMBean`
  Sets the high notification's on/off switch value.

  Specified by:
    `setNotifyHigh` in interface `GaugeMonitorMBean`
  Parameters:
    `value` - The high notification's on/off switch value.
  See Also:
    `GaugeMonitorMBean.getNotifyHigh()`

### getNotifyLow

    public boolean getNotifyLow()

  Description copied from interface: `GaugeMonitorMBean`
  Gets the low notification's on/off switch value.

  Specified by:
    `getNotifyLow` in interface `GaugeMonitorMBean`
  Returns:
    `true` if the gauge monitor notifies when exceeding the low threshold, `false` otherwise.
  See Also:
    `GaugeMonitorMBean.setNotifyLow(boolean)`

### setNotifyLow

    public void setNotifyLow(boolean value)

  Description copied from interface: `GaugeMonitorMBean`
  Sets the low notification's on/off switch value.

  Specified by:
    `setNotifyLow` in interface `GaugeMonitorMBean`
  Parameters:
    `value` - The low notification's on/off switch value.
  See Also:
    `GaugeMonitorMBean.getNotifyLow()`

### getDifferenceMode

    public boolean getDifferenceMode()

  Description copied from interface: `GaugeMonitorMBean`
  Gets the difference mode flag value.

  Specified by:
    `getDifferenceMode` in interface `GaugeMonitorMBean`
  Returns:
    `true` if the difference mode is used, `false` otherwise.
  See Also:
    `GaugeMonitorMBean.setDifferenceMode(boolean)`

### setDifferenceMode

    public void setDifferenceMode(boolean value)

  Description copied from interface: `GaugeMonitorMBean`
  Sets the difference mode flag value.

  Specified by:
    `setDifferenceMode` in interface `GaugeMonitorMBean`
  Parameters:
    `value` - The difference mode flag value.
  See Also:
    `GaugeMonitorMBean.getDifferenceMode()`

### getNotificationInfo

    public MBeanNotificationInfo[] getNotificationInfo()

  Description copied from class: `NotificationBroadcasterSupport`
  Returns a NotificationInfo object contaning the name of the Java class of the notification and the notification types sent.

  Specified by:
    `getNotificationInfo` in interface `NotificationBroadcaster`
  Overrides:
    `getNotificationInfo` in class `NotificationBroadcasterSupport`

### doMonitor

    protected void doMonitor(ObjectName observedObject,
                             java.lang.Object value)

  Specified by:
    `doMonitor` in class `Monitor`

### addObservedObject

    public void addObservedObject(ObjectName objectName)
                           throws java.lang.IllegalArgumentException

  Description copied from interface: `MonitorMBean`
  Adds the specified object in the set of observed MBeans.

  Specified by:
    `addObservedObject` in interface `MonitorMBean`
  Specified by:
    `addObservedObject` in class `Monitor`
  Parameters:
    `objectName` - The object to observe.
  Throws:
    `java.lang.IllegalArgumentException` - the specified object is null.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD